% Figure1_6.m
% It requires the following functions:
% hrk4.m
% rkGL4.m
% pcAB3.m
% fKepler.m
% phiKepler
%
% midpoint2.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
t0=0;  tf=300;   N=1*3000;  N2=N/2; t=[];
h = (tf-t0)/N;
% Initial Conditions 
e=0.2;   x0 = [1-e ; 0; 0; sqrt((1+e)/(1-e))];
q0=[x0(1); x0(2)];  p0=[x0(3); x0(4)]; 
% Energy at initial conditions
H0=((x0(3))^2+(x0(4))^2)/2-1/(sqrt((x0(1))^2+(x0(2))^2));

[t xk4]=rk4(@fKepler,t0,tf,x0,N);
[t xg4]=rkGL4(@fKepler,t0,tf,x0,N);
[t xp4]=pcABM3(@fKepler,t0,tf,x0,N);
[t qn4 pn4]=rkn4(@fKeplerN,t0,tf,q0,p0,N);

 x = x0';th=t0;
q0(1)=x0(1);p0(1)=x0(2);q0(2)=x0(3);p0(2)=x0(4);
for i=1:N;
   th=th+h;
   [q p]=phiKepler(q0,p0,h);
   x=[x; q p];
   q0=q;p0=p;
end

ePK4=sqrt((x(:,1)-xk4(:,1)).^2+(x(:,2)-xk4(:,2)).^2+(x(:,3)-xk4(:,3)).^2+(x(:,4)-xk4(:,4)).^2);
ePG4=sqrt((x(:,1)-xg4(:,1)).^2+(x(:,2)-xg4(:,2)).^2+(x(:,3)-xg4(:,3)).^2+(x(:,4)-xg4(:,4)).^2);
ePP4=sqrt((x(:,1)-xp4(:,1)).^2+(x(:,2)-xp4(:,2)).^2+(x(:,3)-xp4(:,3)).^2+(x(:,4)-xp4(:,4)).^2);
ePN4=sqrt((x(:,1)-qn4(:,1)).^2+(x(:,2)-qn4(:,2)).^2+(x(:,3)-pn4(:,1)).^2+(x(:,4)-pn4(:,2)).^2);

errorHK4 = ((xk4(:,3)).^2+(xk4(:,4)).^2)./2-1./(sqrt((xk4(:,1)).^2+(xk4(:,2)).^2)) - H0;
errorHG4 = ((xg4(:,3)).^2+(xg4(:,4)).^2)./2-1./(sqrt((xg4(:,1)).^2+(xg4(:,2)).^2)) - H0;
errorHP4 = ((xp4(:,3)).^2+(xp4(:,4)).^2)./2-1./(sqrt((xp4(:,1)).^2+(xp4(:,2)).^2)) - H0;
errorHN4 = ((pn4(:,1)).^2+(pn4(:,2)).^2)./2-1./(sqrt((qn4(:,1)).^2+(qn4(:,2)).^2)) - H0;

figure(1)

 subplot(1,2,1)
  hold on
  plot(log10(t),log10(abs(errorHK4(:))),'-k','LineWidth',1.5,'Color',[0 0 0]+0.85)
  plot(log10(t),log10(abs(errorHN4(:))),'-k','LineWidth',1.5)
  plot(log10(t),log10(abs(errorHG4(:))),'-k','LineWidth',1.5,'Color',[0 0 0]+0.5)
  plot(log10(t),log10(abs(errorHP4(:))),'--k','LineWidth',1.5)
  axis([-1 2.5 -8 -2]) 
  xlabel('{\fontsize{14} log_{10}(t) }')   
  ylabel('{\fontsize{14} log_{10}|H(t)-H_0|}')   
  box

  text(1,-4.5,'RK4','FontSize',12)
  text(1,-3,'PC4','FontSize',12)
  text(1.7,-5.3,'RKN4','FontSize',12)
  text(1.5,-6,'RKGL4','FontSize',12)
  
 subplot(1,2,2)
  hold on
  plot(log10(t),log10(ePK4),'-k','LineWidth',1.5,'Color',[0 0 0]+0.85)
  plot(log10(t),log10(ePN4),'-k','LineWidth',1.5)
  plot(log10(t),log10(ePG4),'-k','LineWidth',1.5,'Color',[0 0 0]+0.5)
  plot(log10(t),log10(ePP4),'--k','LineWidth',1.5)
  axis([-1 2.5 -6.5 0.5]) 
  xlabel('{\fontsize{14} log_{10}(t) }')   
  ylabel('{\fontsize{14} log_{10}(err(q,p))}')   
  box
  
  text(1,-0.8,'PC4','FontSize',12)
  text(1.5,-1.7,'RK4','FontSize',12)
  text(1.8,-2.6,'RKN4','FontSize',12)
  text(1.5,-3.8,'RKGL4','FontSize',12)

