%             rkn4.m
% 3-stage 4th-order RKN method
% f: vectorfield
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t q p] = rkn4(f,t0,tf,q0,p0,N)
h = (tf-t0)/N;
t=t0:h:tf; q=q0'; p=p0' ;q1=q0;p1=p0;
for i=1:N;
  t1=t(i); t2 = t(i) + h/2; t3 = t(i) + h;
  K1 = f(t1,q1);
  K2 = f(t2,q1+h*p1/2+h^2*K1/8);
  K3 = f(t3,q1+h*p1  +h^2*K2/2);
  q1 = q1 + h*p1 + h^2*(K1 + 2*K2)/6;
  p1 = p1 + h*(K1 + 4*K2 + K3)/6;
%  q1 = q1 + h*p1 + h^2*(K1 + 4*K2 + K3)/6;
%  p1 = p1 + h*(K1 + 2*K2)/6;
  q = [q ; q1'];
  p = [p ; p1' ];
end

